# std::unordered_set<Key,Hash,KeyEqual,Allocator>::emplace

From cppreference.com
< cpp‎ | container‎ | unordered set

template< class... Args > std::pair<iterator,bool> emplace( Args&&... args ); |  | (since C++11)

Inserts a new element into the container constructed in-place with the given `args` if there is no element with the key in the container.

Careful use of `emplace` allows the new element to be constructed while avoiding unnecessary copy or move operations. The constructor of the new element is called with exactly the same arguments as supplied to `emplace`, forwarded via std::forward<Args>(args).... The element may be constructed even if there already is an element with the key in the container, in which case the newly constructed element will be destroyed immediately.

If rehashing occurs due to the insertion, all iterators are invalidated. Otherwise iterators are not affected. References are not invalidated. Rehashing occurs only if the new number of elements is greater than max_load_factor()*bucket_count().

### Parameters

args | - | arguments to forward to the constructor of the element

### Return value

Returns a pair consisting of an iterator to the inserted element, or the already-existing element if no insertion happened, and a bool denoting whether the insertion took place. True for Insertion, False for No Insertion.

### Exceptions

If an exception is thrown by any operation, this function has no effect.

### Complexity

Amortized constant on average, worst case linear in the size of the container.

### Example

| This section is incomplete Reason: no example

### See also

emplace_hint | constructs elements in-place using a hint (public member function)
insert | inserts elements or nodes (since C++17) (public member function)

Retrieved from "https://en.cppreference.com/mwiki/index.php?title=cpp/container/unordered_set/emplace&oldid=50777"